<template>
  <div class="row view-and-filter-block">
    <div class="col-12 view-and-filter-block__title">VIEW ALL AND FILTER</div>
    <div class="col-12 view-and-filter-block__input-filter">
      <div class="input-group input-group--border">
        <input type="text" class="form-control filter-input" placeholder="Type to filter" aria-label="Type to filter" aria-describedby="basic-addon2" v-model="filter_str" />
      </div>
    </div>
    <div class="col-12 view-and-filter-block__all-list" v-if="todo_list_view.length > 0">
      <div class="view-all-each-item" v-for="(item, index) in todo_list_view" v-bind:key="index" v-bind:style="set_up_color(item.status)">
        <div class="view-all-each-item__name">{{item.name}}</div>
        <div class="view-all-each-item__status">{{item.status}}</div>
      </div>
    </div>
    <div class="col-12 view-and-filter-block__all-list" v-else>
      <p class="view-and-filter-block__all-list--center">Todo list is empty!!!</p>
    </div>
  </div>
</template>

<script>
import './scss/ViewAllAndFilter.scss';
export default {
  name: "ViewAllAndFilter",
  props: {
    'todo_list': {
      type: Array,
      default: () => []
    }
  },
  data() {
    return {
      filter_str: "",
      todo_list_view: this.render(),
      color: "green"
    };
  },
  methods: {
    render(){
      if (this.filter_str == "" || this.filter_str == null){
        this.todo_list_view = this.todo_list;
        return [...this.todo_list];
      }
      else{
        var filter_str_lower = this.filter_str.toLowerCase();
        return this.todo_list.filter(item => item.name.toLowerCase().includes(filter_str_lower));
      }
    },
    set_up_color(status){
      if (status == "COMPLETED"){
        return {
          backgroundColor: "#5b9eed",
          borderColor: "#5b9eed"
        }
      }
      else if (status == "DELETED"){
        return {
          backgroundColor: "red",
          borderColor: "red"
        }
      }
      else{
        return {
          backgroundColor: "orange",
          borderColor: "orange"
        }
      }
    }
  },
  watch: {
    filter_str: function() {
      this.todo_list_view = this.render();
    }
  }

};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
</style>
